//************************************************************************
// T6963.C
// LowLevel Routinen fr LCD-Displays mit T6963
//************************************************************************

#include	"T6963.h"

void  gotoXY (unsigned char X, unsigned char Y)
{  
   unsigned int tmp;
   //goes to pixel X horizontal and Pixel Y vertical. X should be devidable by 8, 0,0 ist top left corner
   tmp= Y* (unsigned int)BYTES_PER_ROW+X+G_BASE;
   lcd_send_data((unsigned char)(tmp%256));   //first low then high byte  
   lcd_send_data((unsigned char)(tmp/256));
   lcd_send_cmd(0x24);
}


void lcd_print(char *txt, char adress_l, char adress_h)
        {
        char c;
        lcd_send_data(adress_l);
        lcd_send_data(adress_h);
        lcd_send_cmd(0x24);

        while((c = *txt++)) //Solange Zeichen grer 0x00
      {
      //if (c == 0) break; //Raus wenn Zeichen gleich 0
      lcd_send_str(c);
      lcd_send_cmd(0xC0);
      }
        }

/**** LCD-Display-Routinen **********************************************/
void lcd_init(void)
        {
        unsigned char t;
		LCD_CTRL = 0xFF;
		//DDRC=0xff;
		P2=0xFF;				//PORTA=0xFF;
        LCD_RST_L();          // Display Reset
                for (t=0; t<250; t++)
                {}          // ca. 250s. Reset
        LCD_RST_H();        // Display Reset fertig
		lcd_send_data(G_BASE%256);//Graphic Home Adress setzen 
        lcd_send_data(G_BASE/256);
        lcd_send_cmd(0x42);
		lcd_send_data(0);//Text Home Adress setzen 
        lcd_send_data(8);
        lcd_send_cmd(0x40);
		lcd_send_data(BYTES_PER_ROW);//16 Bytes pro Zeile
        lcd_send_data(0x00);
        lcd_send_cmd(0x43);
		lcd_send_cmd(0x81);//only graphic mode
		//lcd_send_cmd(0xA7);//cursor 8 Lines high
		lcd_send_cmd(0x98);
        lcd_clear_ram();      // zum Schluss noch das Ram des 
        }                     // Display's lschen

unsigned char lcd_status(void)
        {
		unsigned char status;
        DATA_DIR_IN();          // Port 2 als Eingang
        LCD_CD_H();             // Commando High
        LCD_RD_L();             // Read Low
        LCD_CE_L();             // Chip Enable Low
        status = LCD_READ;  // Status lesen
        LCD_CE_H();             // Chip Enable High
		LCD_RD_H();             // Read High
        status &= (0x03);   // Bits ausmaskieren
		return (status);
        }

unsigned char lcd_status_am(void)
        {
		unsigned char status_am;
        DATA_DIR_IN();          // Port 2 als Eingang
        LCD_CD_H();             // Commando High
        LCD_RD_L();             // Read Low
        LCD_CE_L();             // Chip Enable Low
        status_am = LCD_READ;  // Status lesen
        LCD_CE_H();             // Chip Enable High
		LCD_RD_H();             // Read High
        status_am &= (0x08);   // Bits ausmaskieren
		return (status_am);
        }

void lcd_send_cmd(unsigned char cmd)         // Commando an Display senden        
        {
            while(lcd_status()!=3)
                {
                }
        //DATA_DIR_OUT();             // Port 2 als Ausgang
        LCD_WRITE = cmd; //LCD_WRITE = LCD_CMD;
        LCD_CD_H();             // Commando High
        LCD_WR_L();             // Write Low
        LCD_CE_L();             // Chip Enable Low
        LCD_CE_H();             // Chip Enable High
        LCD_WR_H();             // Write High
        }

void lcd_send_data(unsigned char data)         // Daten an Display senden        
        {
            while(lcd_status()!=3)
                { 
                }
        //DATA_DIR_OUT();             // Port 2 als Ausgang
        LCD_WRITE = data; //LCD_WRITE = LCD_DATA;
        LCD_CD_L();             // Commando High
        LCD_WR_L();             // Write Low
        LCD_CE_L();             // Chip Enable Low
        LCD_CE_H();             // Chip Enable High
        LCD_WR_H();             // Write High
        }

void lcd_send_data_am(unsigned char data)         // Daten an Display senden
        {
            while(lcd_status_am()!=8)
                {
                }
        //DATA_DIR_OUT();        // Port 2 als Ausgang
        LCD_WRITE = data;
        LCD_CD_L();             // Daten Low
        LCD_WR_L();             // Write Low
        LCD_CE_L();             // Chip Enable Low
        LCD_CE_H();             // Chip Enable High
        LCD_WR_H();             // Write High
        }
/*
void lcd_print(const char *progmem_s, char adress_h, char adress_l)
        {
        char c;

        LCD_DATA = adress_l;    // bergebene Adresse setzen
        lcd_send_data();        
        LCD_DATA = adress_h;
        lcd_send_data();
        LCD_CMD = 0x24;
        lcd_send_cmd();

        LCD_CMD = 0xB0;         // Auto Write Mode an (Auto Inkrement)
        lcd_send_cmd();
	
		while ( (c = pgm_read_byte(progmem_s++)))
			{
			lcd_send_str(c);
			}
        LCD_CMD = 0xB2;         // Auto Write Mode aus (Auto Inkrement)
        lcd_send_cmd();
        }*/

void lcd_send_str(unsigned char lcd_dat)
        {
         lcd_send_data_am(lcd_dat - 0x20);     // Daten an Display senden 20h subtrahieren da Display nich ASCII
        }

void lcd_clear_ram(void)
        {
        unsigned int t;
        lcd_send_data(0x00);        // int. Ram des Display's lschen. laut Datenblatt des Herstellers 8kb
        lcd_send_data(0x00);
        lcd_send_cmd(0x24);        
        lcd_send_cmd(0xB0);			// Auto Write Mode an (Auto Inkrement)
                for (t=0; t<8192; t++)
                {
                 lcd_send_data_am(0x00);     // Daten an Display senden
				}        
        lcd_send_cmd(0xB2);		// Auto Write Mode aus (Auto Inkrement)
        }
/*
void lcd_printg(const char *progmem_s, char adress_h, char adress_l)
        {
        char c;

        LCD_DATA = adress_l;    // bergebene Adresse setzen
        lcd_send_data();        
        LCD_DATA = adress_h;
        lcd_send_data();
        LCD_CMD = 0x24;
        lcd_send_cmd();

        LCD_CMD = 0xB0;         // Auto Write Mode an (Auto Inkrement)
        lcd_send_cmd();
	
		while ( (c = pgm_read_byte(progmem_s++)))
			{
			lcd_send_strg(c);
			}
        LCD_CMD = 0xB2;         // Auto Write Mode aus (Auto Inkrement)
        lcd_send_cmd();
        } */

void lcd_send_strg(unsigned char lcd_dat)
        {
        lcd_send_data_am(lcd_dat);     // Daten an Display senden
        }
